#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <poll.h>
#include <pthread.h>
int fd;
int request1[2] = {0xff116f4e, 
                   0x86000000};
void *send_etherbone_request(void *data) {
	sleep(2);
	write(fd, request1, sizeof(request1));
}
int main(int argc, char *argv[]) {
	fd = open("/dev/ebs_wbm_pcie_device", O_RDWR);
	struct pollfd pfd;
	pfd.fd = fd;
	pfd.events = POLLIN;
	int response1[2];
	pthread_t thread;
	pthread_create(&thread, NULL, &send_etherbone_request, NULL); // thread will wait 2 seconds before writing etherbone request
	printf("a) pollresult=%d\n",poll(&pfd,1,-1)); // nothing to read yet. will wait until there is data to read.
	pthread_join(thread, NULL);
	printf("b) pollresult=%d\n",poll(&pfd,1,-1)); // response can be read. will return immediately and return 1.
	read(fd, response1, sizeof(response1));
	for (int i = 0; i < 2; ++i ) {
		printf("%08x -> %08x\n", request1[i], response1[i]);
	}
	return 0;
}
